package org.omg.CORBA;

import org.omg.CORBA.ORBPackage.InconsistentTypeCode;
import org.omg.CORBA.portable.OutputStream;
import java.lang.reflect.InvocationTargetException;
import org.omg.CORBA.ORBPackage.InvalidName;
import java.applet.Applet;
import com.sun.corba.se.impl.orb.ORBImpl;
import sun.reflect.misc.ReflectUtil;
import com.sun.corba.se.impl.orb.ORBSingleton;
import java.io.FileInputStream;
import java.io.File;
import java.util.Properties;
import java.security.AccessController;
import java.security.PrivilegedAction;

public abstract class ORB
{
    private static final String ORBClassKey = "org.omg.CORBA.ORBClass";
    private static final String ORBSingletonClassKey = "org.omg.CORBA.ORBSingletonClass";
    private static ORB singleton;
    
    public ORB() {
    }
    
    private static String getSystemProperty(final String s) {
        return (String)AccessController.doPrivileged(new PrivilegedAction() {
            @Override
            public Object run() {
                return System.getProperty(s);
            }
        });
    }
    
    private static String getPropertyFromFile(final String s) {
        return (String)AccessController.doPrivileged(new PrivilegedAction() {
            private Properties getFileProperties(String pathname) {
                try {
                    File file = new File(pathname);
                    if (!file.exists()) {
                        return null;
                    }
                    Properties properties = new Properties();
                    FileInputStream inStream = new FileInputStream(file);
                    try {
                        properties.load(inStream);
                    }
                    finally {
                        inStream.close();
                    }
                    return properties;
                }
                catch (Exception ex) {
                    return null;
                }
            }
            
            @Override
            public Object run() {
                Properties fileProperties = this.getFileProperties(System.getProperty("user.home") + File.separator + "orb.properties");
                if (fileProperties != null) {
                    String property = fileProperties.getProperty(s);
                    if (property != null) {
                        return property;
                    }
                }
                Properties fileProperties2 = this.getFileProperties(System.getProperty("java.home") + File.separator + "lib" + File.separator + "orb.properties");
                if (fileProperties2 == null) {
                    return null;
                }
                return fileProperties2.getProperty(s);
            }
        });
    }
    
    public static synchronized ORB init() {
        if (ORB.singleton == null) {
            String s = getSystemProperty("org.omg.CORBA.ORBSingletonClass");
            if (s == null) {
                s = getPropertyFromFile("org.omg.CORBA.ORBSingletonClass");
            }
            if (s == null || s.equals("com.sun.corba.se.impl.orb.ORBSingleton")) {
                ORB.singleton = new ORBSingleton();
            }
            else {
                ORB.singleton = create_impl(s);
            }
        }
        return ORB.singleton;
    }
    
    private static ORB create_impl(String str) {
        ClassLoader loader = Thread.currentThread().getContextClassLoader();
        if (loader == null) {
            loader = ClassLoader.getSystemClassLoader();
        }
        try {
            ReflectUtil.checkPackageAccess(str);
            return (ORB)Class.forName(str, true, loader).asSubclass(ORB.class).newInstance();
        }
        catch (Throwable cause) {
            INITIALIZE o = new INITIALIZE("can't instantiate default ORB implementation " + str);
            o.initCause(cause);
            throw o;
        }
    }
    
    public static ORB init(String[] array, Properties properties) {
        String s = null;
        if (properties != null) {
            s = properties.getProperty("org.omg.CORBA.ORBClass");
        }
        if (s == null) {
            s = getSystemProperty("org.omg.CORBA.ORBClass");
        }
        if (s == null) {
            s = getPropertyFromFile("org.omg.CORBA.ORBClass");
        }
        Object create_impl;
        if (s == null || s.equals("com.sun.corba.se.impl.orb.ORBImpl")) {
            create_impl = new ORBImpl();
        }
        else {
            create_impl = create_impl(s);
        }
        create_impl.set_parameters(array, properties);
        return create_impl;
    }
    
    public static ORB init(Applet applet, Properties properties) {
        String s = applet.getParameter("org.omg.CORBA.ORBClass");
        if (s == null && properties != null) {
            s = properties.getProperty("org.omg.CORBA.ORBClass");
        }
        if (s == null) {
            s = getSystemProperty("org.omg.CORBA.ORBClass");
        }
        if (s == null) {
            s = getPropertyFromFile("org.omg.CORBA.ORBClass");
        }
        Object create_impl;
        if (s == null || s.equals("com.sun.corba.se.impl.orb.ORBImpl")) {
            create_impl = new ORBImpl();
        }
        else {
            create_impl = create_impl(s);
        }
        create_impl.set_parameters(applet, properties);
        return create_impl;
    }
    
    protected abstract void set_parameters(String[] p0, Properties p1);
    
    protected abstract void set_parameters(Applet p0, Properties p1);
    
    public void connect(org.omg.CORBA.Object object) {
        throw new NO_IMPLEMENT();
    }
    
    public void destroy() {
        throw new NO_IMPLEMENT();
    }
    
    public void disconnect(org.omg.CORBA.Object object) {
        throw new NO_IMPLEMENT();
    }
    
    public abstract String[] list_initial_services();
    
    public abstract org.omg.CORBA.Object resolve_initial_references(String p0) throws InvalidName;
    
    public abstract String object_to_string(org.omg.CORBA.Object p0);
    
    public abstract org.omg.CORBA.Object string_to_object(String p0);
    
    public abstract NVList create_list(int p0);
    
    public NVList create_operation_list(org.omg.CORBA.Object object) {
        try {
            String name = "org.omg.CORBA.OperationDef";
            ClassLoader loader = Thread.currentThread().getContextClassLoader();
            if (loader == null) {
                loader = ClassLoader.getSystemClassLoader();
            }
            return (NVList)this.getClass().getMethod("create_operation_list", new Class[] { Class.forName(name, true, loader) }).invoke(this, new Object[] { object });
        }
        catch (InvocationTargetException ex) {
            Throwable targetException = ex.getTargetException();
            if ((targetException instanceof Error)) {
                throw (Error)targetException;
            }
            if ((targetException instanceof RuntimeException)) {
                throw (RuntimeException)targetException;
            }
            throw new NO_IMPLEMENT();
        }
        catch (RuntimeException ex2) {
            throw ex2;
        }
        catch (Exception ex3) {
            throw new NO_IMPLEMENT();
        }
    }
    
    public abstract NamedValue create_named_value(String p0, Any p1, int p2);
    
    public abstract ExceptionList create_exception_list();
    
    public abstract ContextList create_context_list();
    
    public abstract Context get_default_context();
    
    public abstract Environment create_environment();
    
    public abstract OutputStream create_output_stream();
    
    public abstract void send_multiple_requests_oneway(Request[] p0);
    
    public abstract void send_multiple_requests_deferred(Request[] p0);
    
    public abstract boolean poll_next_response();
    
    public abstract Request get_next_response() throws WrongTransaction;
    
    public abstract TypeCode get_primitive_tc(TCKind p0);
    
    public abstract TypeCode create_struct_tc(String p0, String p1, StructMember[] p2);
    
    public abstract TypeCode create_union_tc(String p0, String p1, TypeCode p2, UnionMember[] p3);
    
    public abstract TypeCode create_enum_tc(String p0, String p1, String[] p2);
    
    public abstract TypeCode create_alias_tc(String p0, String p1, TypeCode p2);
    
    public abstract TypeCode create_exception_tc(String p0, String p1, StructMember[] p2);
    
    public abstract TypeCode create_interface_tc(String p0, String p1);
    
    public abstract TypeCode create_string_tc(int p0);
    
    public abstract TypeCode create_wstring_tc(int p0);
    
    public abstract TypeCode create_sequence_tc(int p0, TypeCode p1);
    
    @Deprecated
    public abstract TypeCode create_recursive_sequence_tc(int p0, int p1);
    
    public abstract TypeCode create_array_tc(int p0, TypeCode p1);
    
    public TypeCode create_native_tc(String s, String s2) {
        throw new NO_IMPLEMENT();
    }
    
    public TypeCode create_abstract_interface_tc(String s, String s2) {
        throw new NO_IMPLEMENT();
    }
    
    public TypeCode create_fixed_tc(short n, short n2) {
        throw new NO_IMPLEMENT();
    }
    
    public TypeCode create_value_tc(String s, String s2, short n, TypeCode typeCode, ValueMember[] array) {
        throw new NO_IMPLEMENT();
    }
    
    public TypeCode create_recursive_tc(String s) {
        throw new NO_IMPLEMENT();
    }
    
    public TypeCode create_value_box_tc(String s, String s2, TypeCode typeCode) {
        throw new NO_IMPLEMENT();
    }
    
    public abstract Any create_any();
    
    @Deprecated
    public Current get_current() {
        throw new NO_IMPLEMENT();
    }
    
    public void run() {
        throw new NO_IMPLEMENT();
    }
    
    public void shutdown(boolean b) {
        throw new NO_IMPLEMENT();
    }
    
    public boolean work_pending() {
        throw new NO_IMPLEMENT();
    }
    
    public void perform_work() {
        throw new NO_IMPLEMENT();
    }
    
    public boolean get_service_information(short n, ServiceInformationHolder serviceInformationHolder) {
        throw new NO_IMPLEMENT();
    }
    
    @Deprecated
    public DynAny create_dyn_any(Any any) {
        throw new NO_IMPLEMENT();
    }
    
    @Deprecated
    public DynAny create_basic_dyn_any(TypeCode typeCode) throws InconsistentTypeCode {
        throw new NO_IMPLEMENT();
    }
    
    @Deprecated
    public DynStruct create_dyn_struct(TypeCode typeCode) throws InconsistentTypeCode {
        throw new NO_IMPLEMENT();
    }
    
    @Deprecated
    public DynSequence create_dyn_sequence(TypeCode typeCode) throws InconsistentTypeCode {
        throw new NO_IMPLEMENT();
    }
    
    @Deprecated
    public DynArray create_dyn_array(TypeCode typeCode) throws InconsistentTypeCode {
        throw new NO_IMPLEMENT();
    }
    
    @Deprecated
    public DynUnion create_dyn_union(TypeCode typeCode) throws InconsistentTypeCode {
        throw new NO_IMPLEMENT();
    }
    
    @Deprecated
    public DynEnum create_dyn_enum(TypeCode typeCode) throws InconsistentTypeCode {
        throw new NO_IMPLEMENT();
    }
    
    public Policy create_policy(int n, Any any) throws PolicyError {
        throw new NO_IMPLEMENT();
    }
}
